local vehicles = {}

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(0)
		if GetSeatPedIsTryingToEnter(PlayerPedId()) == -1 and not table.contains(vehicles, GetVehiclePedIsTryingToEnter(PlayerPedId())) then
			table.insert(vehicles, {GetVehiclePedIsTryingToEnter(PlayerPedId()), IsVehicleEngineOn(GetVehiclePedIsTryingToEnter(PlayerPedId()))})
		elseif IsPedInAnyVehicle(PlayerPedId(), false) and not table.contains(vehicles, GetVehiclePedIsIn(PlayerPedId(), false)) then
			table.insert(vehicles, {GetVehiclePedIsIn(PlayerPedId(), false), IsVehicleEngineOn(GetVehiclePedIsIn(PlayerPedId(), false))})
		end
		
		for i, vehicle in ipairs(vehicles) do
			if DoesEntityExist(vehicle[1]) then
				if (GetPedInVehicleSeat(vehicle[1], -1) == PlayerPedId()) or IsVehicleSeatFree(vehicle[1], -1) then
					if IsVehicleDriveable(vehicle[1]) == 1 and GetVehicleEngineHealth(vehicle[1]) > 201 then
						--Why 200 you may ask?  In GTA V the planes at 200 engine health stop working;  If this isn't the case for the vehicletype you're after, simply remove the "and GetVehicle.... all the way up to the number 201"
						SetVehicleEngineOn(vehicle[1], vehicle[2], true, false)
						SetVehicleJetEngineOn(vehicle[1], vehicle[2])
						if not IsPedInAnyVehicle(PlayerPedId(), false) or (IsPedInAnyVehicle(PlayerPedId(), false) and vehicle[1]~= GetVehiclePedIsIn(PlayerPedId(), false)) then
							if IsThisModelAHeli(GetEntityModel(vehicle[1])) or IsThisModelAPlane(GetEntityModel(vehicle[1])) then
								if vehicle[2] then
									SetHeliBladesFullSpeed(vehicle[1])
								end
							end
						end
					else
						SetVehicleEngineOn(vehicle[1], vehicle[2], false, false)
						SetVehicleJetEngineOn(vehicle[1], false)
					end
				end
			else
				table.remove(vehicles, i)
			end
		end
	end
end)

RegisterCommand('engine', function()
	local veh
	local StateIndex

	for i, vehicle in ipairs(vehicles) do
		if vehicle[1] == GetVehiclePedIsIn(PlayerPedId(), false) then
			--sets the veh variable as the vehicle you're currently in
			veh = vehicle[1]
			StateIndex = i
			--Set's the state index = 1
		end
	end
	Citizen.Wait(0)


	--The below is simply to generate a timer for requesting control of entity
	local netTime = 15
    	NetworkRequestControlOfEntity(veh)
    	while not NetworkHasControlOfEntity(veh) and netTime > 0 do 
        	NetworkRequestControlOfEntity(veh)
        	Citizen.Wait(1)
        	netTime = netTime -1
    	end


		if IsPedInAnyVehicle(PlayerPedId(), false) then 
			if (GetPedInVehicleSeat(veh, -1) == PlayerPedId()) then
				vehicles[StateIndex][2] = not GetIsVehicleEngineRunning(veh)
			end
		end
end)

function table.contains(table, element)
	for _, value in pairs(table) do
		if value[1] == element then
			return true
		end
	end
	return false
end

function loadAnimDict(dict)
    while (not HasAnimDictLoaded(dict)) do
        RequestAnimDict(dict)
        Citizen.Wait(5)
    end
end
